/// <reference path="typings/tp.d.ts">/>
/// <reference path="typings/game-object.d.ts">/>

const { BasicColors } = require('./shared');

/**
 * @type {GameObject}
 */
let refObject = this.refObject;

let secLeft = 0;
let timer;

refObject.setName('Grab to reset - release to start');
refObject.onGrab.add(() => resetTimer());
refObject.onReleased.add(() => startTimer(10));

/**
 * Start timer
 * @param {number} sec count of seconds
 */
function startTimer(sec) {
  // refObject.setPrimaryColor(BasicColors.red); // Weird effect on color change when player hold object
  secLeft = sec;
  const iter = () => {
    if (secLeft === 0) {
      resetTimer();
      return;
    }

    timer = setTimeout(() => {
      iter();
      if (secLeft === 0) {
        world.broadcastChatMessage(`-- Times up --`, BasicColors.orange);
      } else {
        world.broadcastChatMessage(`-- ${secLeft}s left --`, BasicColors.orange);
      }
      secLeft--;
    }, 1000);
  };
  iter();
}

/**
 * Reset seconds counter
 */
function resetTimer() {
  refObject.setPrimaryColor(BasicColors.green);
  secLeft = 0;
  clearTimeout(timer);
}