/// <reference path="typings/tp.d.ts">/>
/// <reference path="typings/game-object.d.ts">/>

const { SlotsColorName, BasicColors } = require('./shared');

refObject.setName('Grab this to pick random player');
refObject.onReleased.add((_, interPlayer) => {
  const rndPlayer = getRandomPlayer();
  const rndPlayerColor = SlotsColorName[rndPlayer.getSlot()];
  const clickPlayerColor = SlotsColorName[interPlayer.getSlot()];
  world.broadcastChatMessage(`Player ${interPlayer.getName()} (${clickPlayerColor}) picks ${rndPlayer.getName()} (${rndPlayerColor})`, BasicColors.white);
});

function getRandomPlayer() {
  const players = world.getAllPlayers();
  const randomIdx = getRandomInt(0, players.length - 1);
  return players[randomIdx];
}

function getRandomInt(min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);
  return Math.floor(Math.random() * (max - min + 1)) + min;
}
